{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X- }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit VdtTools;

interface

uses Dos, Crt, XSer, Colors, VDTDisp, Video60, EmulM2;

const SOFTNAME =  'CONCEPT';
      VERSION  =  '0.60 25';
      AUTEUR   =  'T.JAOUEN';
      COPYRIGHT=  '1988-92 T.JAOUEN';

      MaxMem  = 99; { 20; }
      MaxAnn  = 99; { 6; }

      MaxUndo = MaxAnn*ScreenHigh;


{ --- attention: l'ordre a de l'importance : --- }
type Panel_map = record
                   Graphik    : byte;
                   Panel      : word;
                   PanelActif : word;
                 end;

const

     _RIEN        = 250;
     _CarGraphik  = 240;

     Complement  = 176;
     Tabulation  = 8;
     BasePanel   = Trait+Stable;

const
      E_OK      = 1;
      E_REPRISE = 2;
      E_ABANDON = 4;
      E_IGNORE  = 8;
      E_OUI     = 16;
      E_NON     = 32;

      MPRO1 = #27#$39;
      MPRO2 = #27#$3A;
      MPRO3 = #27#$3B;
      MOFF  = #$60;
      MON   = #$61;
      MSTART = #$69;
      MSTOP  = #$6A;
      MROULEAU = #$43;
      MEEcran = #$50;   { module emeteur code }
      MEClavier = #$51;
      MEModem = #$52;
      MEPrise = #$53;
      MREcran = #$58;   { module recepteur code }
      MRClavier = #$59;
      MRModem = #$5A;
      MRPrise = #$5B;

{ ****************** VIDEO ******************** }


type
   Param_map = record
    IntroCur   : byte;
    VideLnZero : boolean;
    VideEcran  : boolean;

    CSI        : Boolean;    { Nouveau ! depuis Concept 0.60 }

    TypeRTIC   : boolean;
    ModeAff    : byte;       { ex AffHautBas }
    SauteVide  : boolean;
    ComplAsSpace : boolean;  { ex ComplementSpace }
    OptRepet   : Boolean;
    PlaceCur   : boolean;
    PLigne     : byte;
    PColonne   : byte;
    PPanel     : word;
    ConcluCur  : byte;
    LongChain  : byte; { nbre de fichier chaine }
    LgCode1    : byte; { longueur debut }
    LgCode2    : byte; { longueur fin }

    { Depuis Concept 0.60  1 }

    Inverse       : Boolean;
    ZigZag        : Boolean;

    OptInvGrp     : Boolean;
    OptInvTxt     : Boolean;
    xRep          : Boolean;
    ForceDelGrp   : Boolean;
    ForceDelTxt   : Boolean;
    OptSpclGrp    : Boolean;
    OptSpclTxt    : Boolean;
    C15Clr        : Boolean;
    OptMem        : Byte;
    DebCursor     : Boolean;
    ForceCur      : Boolean;

    { Depuis Concept 0.60  2 }

    NoCR          : Boolean;

                 end;

type MemPg_Rec = record
         Ram         : VDispRam;
         DRCS        : VDispRamDRCS;
         Param       : Param_map;
         Back        : String;
         Chain       : String;
         Code1       : String;
         Code2       : String;
         FileName    : String[12];
         IntroRAff   : Boolean;
         Change      : Boolean;
         UndoSerie   : Longint;
         ReadSerie   : Longint;
         TotalCodes  : Word;
         DiffCodes   : Integer;
         ValidCodes  : Boolean;
       end;
     PMemPg_Rec = ^MemPg_Rec;

{ ***************** MEMOIRE COMPO ************* }

var PB : panel_map; { Panel Block }

    ExtG1 : Boolean;   { TRUE=>code des graph DRCS G1 40  5E et 7F }

    PXhaut,PYhaut,PXbas,PYbas : byte;



type
     point_map     = record
                       case word of
                         FALSE : (point : pointer);
                         TRUE  : (Ofs,Seg : word);
                     end;
     seg_map       = record
                       long : word;
                       case word of
                         FALSE : (point : pointer);
                         TRUE  : (Ofs,Seg : word);
                     end;

     UndoRec = Record
       nMem      : Byte;     { n mmoire }
       nLn       : Byte;     { n ligne }
       nSerie    : Longint;  { n srie }
       Ready     : Boolean;  { valide ? }
       Unused    : Byte;
       Line      : VDispRamLine;
      End;

     PUndoRec = ^UndoRec;

var
    TabMem   : array[1..MaxMem] of PMemPg_Rec;
    TabUndo  : Array[0..MaxUndo-1] Of PUndoRec;
    UndoRead : Word;
    UndoWrite: Word;
    UndoNb   : Word;


const
      M_HautBas      = 0;
      M_BasHaut      = 1;
      M_Montant      = 2;
      M_Descendant   = 3;
      M_GaucheDroite = 4;
      M_DroiteGauche = 5;


      InitParam : Param_map = (
        IntroCur     : 0;
        VideLnZero   : false;
        VideEcran    : true;

        CSI          : FALSE;

        TypeRTIC     : false;
        ModeAff      : M_HautBas;
        SauteVide    : true;
        ComplAsSpace : false;
        OptRepet     : TRUE;
        PlaceCur     : false;
        PLigne       : 0;
        PColonne     : 0;
        PPanel       : BasePanel;
        ConcluCur    : 0;
        LongChain    : 0;
        LgCode1      : 0;
        LgCode2      : 0;

        { Depuis Concept 0.60  1 }

        Inverse       : FALSE;
        ZigZag        : FALSE;

        OptInvGrp     : FALSE;
        OptInvTxt     : FALSE;
        xRep          : FALSE;
        ForceDelGrp   : FALSE;
        ForceDelTxt   : FALSE;
        OptSpclGrp    : TRUE;
        OptSpclTxt    : FALSE;
        C15Clr        : FALSE;
        OptMem        : OM_Nothing;
        DebCursor     : FALSE;
        ForceCur      : FALSE;

        { Depuis Concept 0.60  2 }

        NoCR          : FALSE
       );

Type
     TpMiniRec = record
         Id  : char;
         Tp  : byte;
       end;

const TPM_NULL  = 0;
      TPM_M1    = 1;
      TPM_M1B   = 2;
      TPM_M2    = 3;
      TPM_M10   = 4;
      TPM_M10B  = 5;
      TPM_M5    = 6;
      TPM_M12   = 7;
      NbTpMini = 7;
      TabTpMini : array[0..NbTpMini] of string[4] =
        ('????','M1','M1B','M2','M10','M10B','M5','M12');
      NbGenreMini = 14;
      TabGenreMini : array[1..NbGenreMini] of TpMiniRec = (
         ( Id:'a'; Tp:TPM_M1 ),
         ( Id:'b'; Tp:TPM_M1 ),
         ( Id:'c'; Tp:TPM_M1 ),
         ( Id:'d'; Tp:TPM_M10 ),
         ( Id:'e'; Tp:TPM_M10 ),
         ( Id:'f'; Tp:TPM_M10 ),
         ( Id:'r'; Tp:TPM_M1 ),
         ( Id:'s'; Tp:TPM_M1 ),
         ( Id:'t'; Tp:TPM_M1 ),
         ( Id:'u'; Tp:TPM_M1B ),
         ( Id:'v'; Tp:TPM_M2 ),
         ( Id:'w'; Tp:TPM_M10B ),
         ( Id:'y'; Tp:TPM_M5 ),
         ( Id:'z'; Tp:TPM_M12 )
        );


      VATTR_Graph     = 1;    { xxx1 : affiche graphisme }
      VATTR_DRCS      = 2;    { xx1x : et DRCS }
      VATTR_Colors    = 4;    { x1xx : et couleurs }
      VATTR_RVS       = 8;    { 1xxx : RVS }


type CfgRec = Record
        TpMini : byte;    { type de minitel }
        NEIGE  : boolean;
        SOURIS : boolean;
        COM    : byte;    { numro de com: 0=>non standard }
        IRQ    : word;
        ADR    : word;
        Speed  : byte;
        Reel   : Byte;
        CZ     : Integer;
        Delay  : Word;
        LgIN   : word;
        LgOUT  : word;
        NbreMem: word;
        NbreAnn: word;
        NbreUndo : Word;
        NumPrt : word;
        VitX   : word;
        VitY   : word;
        NB     : boolean; { Noir & Blanc ou couleur }
        VMode  : Byte;
        PAUSE  : boolean;

        ChChain   : String;  { chemin de recherche }
        ChSave    : PathStr; { chemin de sauvegarde }
        Ext       : String[3];
        BackUp    : Boolean;   { crer un backup ??? }
        Slow      : Boolean;   { initialisation lente }

        Emul      : EmulCfg;
        ModMntel  : Boolean;
        Silence   : Boolean;   { Silence sur la ligne ... }
        Sound     : Boolean;

        EmulChDRCS   : Boolean;    { Emul DRCS chain ??? }

        EmulMdPage   : Boolean;    { Emulateur interne }
        EmulDRCS     : Boolean;
        EmulAuto     : Boolean;
        GlobalRAff   : Boolean;
        IntroRAff    : Boolean;

        VAttr        : Word;
        Grey         : Boolean;
        EGALight     : Boolean;
      end;

const Speed75   = 0;
      Speed300  = 1;
      Speed1200 = 2;
      Speed4800 = 3;
      Speed9600 = 4;

      Cfg : CfgRec = (
         TpMini : TPM_NULL;  { type minitel indefini }
         NEIGE  : false;
         SOURIS : true;
         COM    : 1;
         IRQ    : 4;
         ADR    : $3F8;     { indefinie mais initialiser dans param }
         Speed  : Speed4800;
         Reel   : Speed1200;
         CZ     : 0;        { calcul lorsque "Speed" et "reel" connu }
         Delay  : 0;        { idem }
         LgIN   : 1024;
         LgOUT  : 6144;
         NbreMem: 10;
         NbreAnn: 2;
         NbreUndo: 0;      { dpendant de "NbreAnn" }
         NumPrt : 0;
         VitX   : 8;
         VitY   : 16;
         NB     : false;   { couleur par dfaut! }
         VMode  : VMODE_UNDEF;
         PAUSE  : FALSE;   { autorise l'emploi de 0 pour combler }

         ChChain      : '';
         ChSave       : '';
         Ext          : 'VDT';
         BackUp       : TRUE;
         Slow         : FALSE;

         Emul         : (
           EmulTrans     : FALSE;
           VisuelConvert : TRUE;
           (*
           ToScreen      : FALSE;
           ShowCur       : FALSE;
           SX            : 20;
           SY            : 0;
           *)
           RTIC          : TRUE;
           InsLowOnly    : FALSE;
           C15Clr        : FALSE
          );
         ModMntel   : FALSE;
         Silence    : FALSE;
         Sound      : TRUE;
         EmulChDRCS : TRUE;
         EmulMdPage : TRUE;
         EmulDRCS   : TRUE;
         EmulAuto   : TRUE;
         GlobalRAff : TRUE;
         IntroRAff  : TRUE;

         VAttr      : VATTR_Graph+VATTR_DRCS+VATTR_COLORS+VATTR_RVS;
         Grey       : TRUE;
         EGALight   : FALSE
        );



{ **************** ATTRIBUT & PANEL ***********  }
type
     att_map        = record
                        Long : byte;
                        Bit  : byte;
                      end;

const
     bit_att        : array [0..6] of att_map =
                      (( Long : 7 ; Bit : 0 ),   { trait  }
                       ( Long : 7 ; Bit : 3 ),   { fond   }
                       ( Long : 3 ; Bit : 6 ),   { taille }
                       ( Long : 1 ; Bit : 8 ),   { Inver. }
                       ( Long : 1 ; Bit : 9 ),   { Stable }
                       ( Long : 1 ; Bit : 10 ),  { Souli. }
                       ( Long : 1 ; Bit : 11 )); { Masqu }

{ ****************** PANEL ****************** }

const
     PanelX        = 1;
     PanelY        = 9;

     NbreAtt       = 7;
     TxtAtt         : array [0..NbreAtt-1] of string [9]
                      = ('Trait   :','Fond    :','Taille  :','Invers :',
                         'Stable  :','Soulign:','Masqu  :');
     TxtCoul        : array [0..7] of string [9]
                      = ( ' Noir    ',' Bleu    ',' Rouge   ',' Magenta ',
                          ' Vert    ',' Cyan    ',' Jaune   ',' Blanc   ');
     TxtTail        : array [0..3] of string [9]
                      = ( ' Normale ',' Haute   ',' Large   ',' Double  ');
     TxtBin         : array [0..1] of string [9]
                      = ( ' Non     ',' Oui     ');

     PanelGraX     = 15;
     PanelGraY     = 17;

var
     AttActif       : array[0..NbreAtt-1] of boolean;

{ ****************** VIDEOTEX ********************* }

const
      Touche_Ens : set of char = [#21,#32..#133,#135..#154,#156,#160..#163,
                                  #171..#172,#179,#196,#225,#237,#241,#246,#248];
      ConvertLong = 14;
      PC_Compo : array [0..ConvertLong,0..1] of byte =
          ( (129,24),(24,27),(38,25),(25,26),(127,96),(120,172),(121,171),
            (122,225),(30,143),(18,144),(130,246),(131,241),
            (22,146),(36,145),(21,237) );

      TabBit : array [0..3] of byte = (32,223,220,219);
      tab_attrib : array [0..3] of byte = (3,14,115,126);

const couleur : array [0..7] of byte = (0,4,1,5,2,6,3,7);

var  cM      : PMemPg_Rec;

type VdtString = string[3];

function  TradString( var s : string; Var EmulStr : Boolean ) : word;
function  GraphCorrector( val : byte) : byte;
function  InvGraphCorrector( val : byte) : byte;
function  ReadAtt ( ref : word; num_att : byte) : byte;
procedure WrtAtt ( var ref : word; num_att , valeur : byte);
Procedure ClrMemChange( Var M : MemPg_Rec );
Procedure MemChange( Var M : MemPg_Rec );
Procedure NewTotalCodes( Var M : MemPg_Rec; Total : Word );
procedure InitParametrage( var M : MemPg_Rec );
procedure InitMemPg( var M : MemPg_Rec );
Function  Hexa( b : Byte ) : String;

Procedure _AffVdtChar( c : Char; x, y : Byte; Attr : Word );
Procedure AffVdtChar( c : Char; x, y : Byte; Attr : Word );
procedure AffDataShowCadre( x, y : byte);

Procedure Beep;


function GivTxtAtt (ref : word; num_att : byte) : string;
procedure AffAtt ( ref : word; num_att : byte);
Function  CalcGraphCode( g : Byte; DRCSActif : Boolean ) : Byte;

procedure IncAtt( var ref : word; att : byte);
procedure DecAtt( var ref : word; att : byte);

Type ComSolo = Object(ComX)
         Function  Init( Adr : Word; Irq : Byte;
                         Speed : Word; Param : Byte;
                         LgIn, LgOut : Word ) : Boolean;
         Procedure Done;
         Procedure Clear;
         Procedure Write( texte : string );
         Procedure BlockWrite( Var p; Lg : Word );
         Procedure WaitOutEmpty;
       End;

Var  Mntl : ComSolo;         { dsigne le minitel }
(*
Function  SmallPanel( CurX, CurY : Byte;
                      Var p; SizeTab : Byte; Inv : Boolean;
                      nc : Byte; Var result : Byte ) : Boolean;
*)
implementation

(*
Function  SmallPanel( CurX, CurY : Byte;
                      Var p; SizeTab : Byte; Inv : Boolean;
                      nc : Byte; Var result : Byte ) : Boolean;
{ par rapport a la position du curseur CurX, CurY }
Var Tab : Array[0..20] Of String[9] Absolute p;
    Zn  : Zn_Rec;
    y   : Byte;
Begin
 If nc>=SizeTab Then nc := SizeTab-1;
 y := CurY+(SizeTab Div 2);
 If y+(SizeTab Div 2)+2>=25 Then y := 25-((SizeTab Div 2)+2);
 Zn.x := CurX+1;
 Zn.y := y;
 Zn.lg := 11;
 Zn.Ht := SizeTab+2;

 PushZn(Zn);
 ClrZn(Zn,CWind);
 CCdrZn(Zn,CDRNORM,CCadre);
 PopZn;

 GetKey;
End;
*)

Procedure Beep;
Var i : Byte;
    x : Word;
Begin
 If Cfg.Sound Then
  Begin
   x := 850;
   For i := 1 To 10 Do
    Begin
     Sound(x);
     Dec(x,5);
     Delay(10);
    End;
   NoSound;
  End;
End;


Function  CalcCheckUpSpeed( Baud : Word ) : Byte; Assembler;
Asm
    MOV  AX, 640
    XOR  DX, DX
    DIV  [Baud]
    MOV  CL, 16
@ENCORE:
    SHL  AX, 1
    JC   @FIN
    LOOP @ENCORE
@FIN:
    MOV  AL, CL
End;


Function  ComSolo.Init;
Begin
 If (Irq=0) And Not(InstCheckUp(CalcCheckUpSpeed(Speed))) Then Init := FALSE
 Else
  If ComX.Init(Adr,Irq,Speed,Param,LgIn,LgOut) Then Init := TRUE
  Else
   Begin
    If Irq=0 Then KillCheckUp;
    Init := FALSE;
   End;
End;


Procedure  ComSolo.Done;
Begin
 ComX.Done;
 KillCheckUp;
End;


Procedure ComSolo.Clear;
Begin
 ReceiveClear;
 TransmitClear;
End;


Procedure ComSolo.Write( texte : string );
Var i : Word;
Begin
 i := 0;
 While i<Length(texte) Do Inc(i,Transmit(texte[i+1],Length(texte)-i));
End;


Procedure ComSolo.BlockWrite( Var p; Lg : Word );
Type Buffer = Array[0..10000] Of Byte;
Var i : Word;
Begin
 i := 0;
 While i<Lg Do Inc(i,Transmit(Buffer(p)[i],Lg-i));
End;


Procedure ComSolo.WaitOutEmpty;
Begin
 While TransmitCount>0 Do;
End;



procedure InitParametrage( var M : MemPg_Rec );
begin
  M.param      := InitParam;
  M.Back       := '';
  M.Chain      := '';
  M.Code1      := '';
  M.Code2      := '';
  M.TotalCodes := 0;
end;


Procedure ClrMemChange( Var M : MemPg_Rec );
Begin
 M.Change     := FALSE;
(* M.ValidCodes := FALSE; *)
End;


Procedure MemChange( Var M : MemPg_Rec );
Begin
 M.Change     := TRUE;
 M.ValidCodes := FALSE;
End;


Procedure NewTotalCodes( Var M : MemPg_Rec; Total : Word );
Begin
 M.ValidCodes := TRUE;
 M.DiffCodes  := Integer(Total-M.TotalCodes);
 M.TotalCodes := Total;
End;


procedure InitMemPg( var M : MemPg_Rec );
begin
  InitParametrage(M);
  M.FileName   := '';
  M.IntroRAff  := Cfg.IntroRAff;
  M.ValidCodes := FALSE;
  ClrMemChange(M);

  ClearRam(@M.Ram);
  ClearRamDRCS(@M.DRCS);
end;

function TradString( var s : string; Var EmulStr : Boolean ) : word;
{ traduit s en chaine, dans s }
{ renvoi 0 si la chaine est traduite, sinon, renvoi la position de l'erreur }
var lg : word;
    read : word;
    c  : char;
  function GetNumber : boolean;
  var x : byte;
  label la,la2,la3;
  begin
    GetNumber := FALSE;
    inc(read);
    if read>length(s) then exit;
    c := s[read];
    if (c>='0') and (c<='9') then
      begin
        x := 0;
        repeat
          x := x*10+(byte(c)-byte('0'));
          if x>127 then exit; { hors limite }
          inc(read);
          if (read>length(s)) then goto la;
          c := s[read];
        until (c<'0') or (c>'9');
la:     inc(lg);
        s[lg] := char(x);
        GetNumber := TRUE;
      end
    else
      if c='$' then
        begin { saisie Hexa }
          inc(read);
          if read>length(s) then exit;
          c := UpCase(s[read]);
          if ((c>='0') and (c<='9')) or ((c>='A') and (c<='F')) then
            begin
              x := 0;
              repeat
                if c>='A' then x := x*16+((byte(c)-byte('A'))+10)
                else x := x*16+(byte(c)-byte('0'));
                if x>127 then exit; { hors limite }
                inc(read);
                if read>length(s) then goto la2;
                c := s[read];
              until not(((c>='0') and (c<='9')) or ((c>='A') and (c<='F')));
la2:          inc(lg);
              s[lg] := char(x);
              GetNumber := TRUE;
            end
          else GetNumber := FALSE;
        end
      else
        if c='%' then
          begin { saisie binaire }
            inc(read);
            if read>length(s) then exit;
            c := UpCase(s[read]);
            if ((c>='0') and (c<='1')) then
              begin
                GetNumber := TRUE;
                x := 0;
                repeat
                  x := x*2+(byte(c)-byte('0'));
                  if x>127 then exit; { hors limite }
                  inc(read);
                  if read>length(s) then goto la3;
                  c := s[read];
                until not((c>='0') and (c<='1'));
la3:            inc(lg);
                s[lg] := char(x);
                GetNumber := TRUE;
              end
            else GetNumber := FALSE;
          end
        else GetNumber := FALSE;
  end;
  function GetChar : boolean;
  begin
    GetChar := FALSE;
    while (TRUE) do
      begin
        inc(read);
        if read>length(s) then exit;
        c := s[read];
        if c>#127 then
          begin
            GetChar := FALSE; { hors limite }
            exit;
          end;
        if c='''' then
          begin
            inc(read);
            if read>length(s) then
              begin
                GetChar := TRUE; { chaine complete }
                exit;
              end;
            c := s[read];
            if c='''' then
              begin
                inc(lg);
                s[lg] := '''';
              end
            else
              begin
                GetChar := TRUE;
                exit;
              end;
          end
        else
          begin
            inc(lg);
            s[lg] := char(c);
          end;
      end;
  end;
begin
  lg := 0;
  read := 1;
  If (s<>'') And (s[1]='!') Then
   Begin
    Delete(s,1,1);
    EmulStr := FALSE;
   End
  Else EmulStr := TRUE;

  while read<=length(s) do
    begin
      c := s[read];
      if c='#' then
        begin
          if not GetNumber then
            begin { erreur }
              TradString := read;
              exit;
            end;
        end
      else
        if c='''' then
          begin
            if not GetChar then
              begin
                TradString := read;
                exit;
              end;
          end
        else
          begin
            TradString := read;
            exit;
          end;
    end;
  { chaine complete }
  s[0] := char(lg);
  TradString := 0;
{  writeln('TradString="',s,'"'); }
end;


function GraphCorrector( val : byte) : byte;
{ on sous entend que la valeur est obligatoirement superieur ou egal a 32 }
{ car c'est ainsi que l'information est place en memoire }
begin
  val := (val and 127) or 32;
  if val = 127 then val := 95;
  GraphCorrector := val;
end;

function InvGraphCorrector( val : byte) : byte;
{ effectue l'operation inverse de GraphCorrector, c-a-d que l'on restitue }
{ la valeur graphique de calcul (0-63) }
begin
  val := val and 127;
  if val>=96 then dec(val,64)
  else
    if val=95 then val := 63
    else dec(val,32);
  InvGraphCorrector := val;
end;

function ReadAtt ( ref : word; num_att : byte) : byte;
begin
  ReadAtt := (( ref and (bit_att[num_att].Long shl bit_att[num_att].bit))
                shr bit_att[num_att].bit);
end;

procedure WrtAtt ( var ref : word; num_att , valeur : byte);
begin
  ref := (ref and
         ((bit_att[num_att].long shl bit_att[num_att].bit) xor 32767 )) or
         (valeur shl bit_att[num_att].bit);
end;


Function Hexa( b : Byte ) : String;
Var s : Array[1..2] Of Char;
    z : Byte;
Begin
 z := (b Shr 4) And 15;
 If z<10 Then s[1] := Char(Byte('0')+z)
 Else s[1] := Char(Byte('A')-10+z);

 z := b And 15;
 If z<10 Then s[2] := Char(Byte('0')+z)
 Else s[2] := Char(Byte('A')-10+z);

 Hexa := s;
End;


Const
     RIEN        = 250;
     CarGraphik  = 240;

Procedure WrtVdtChar( c : Char; x, y : Byte; Attr : Word; Reverse : Boolean );
Var pix : DtScr_Rec;
    t, f : Byte;
Begin
 if c=#0 then
   begin
     pix.car := RIEN;
     pix.att := CRien;
   end
 else
   begin
     if (Attr and Graphik)=0 then pix.car := Byte(c)
     else pix.car := CarGraphik;
     If attr And DRCS=0 Then
      Begin
       If VideoEGA And
            (Cfg.VAttr And VATTR_RVS<>0) And
            (Attr And (Inverse+Graphik)=Inverse) Then
          Begin
           Attr := (Attr And Not(7+56)) Or
                   ((Attr And 7) Shl 3) Or
                   ((Attr And 56) Shr 3);
           pix.att := CRvs;  { en attendant... }
          End
       Else pix.att := CTout;

       If VideoEGA And (Cfg.VAttr And VATTR_COLORS<>0) Then
        Begin
         pix.att := (Attr And 7)+((Attr And 56) Shl 1);
        End;
      End
     Else
      Begin
       If VideoEGA Then
        Begin
         pix.Att := CDRCS;
         If (Cfg.VAttr And VATTR_RVS<>0) And
            (Attr And (Inverse+Graphik)=Inverse) Then
          Begin
           Attr := (Attr And Not(7+56)) Or
                   ((Attr And 7) Shl 3) Or
                   ((Attr And 56) Shr 3);
          End;

         If (Cfg.VAttr And VATTR_DRCS<>0) Then
          Begin
           If (Cfg.VAttr And VATTR_COLORS<>0) Then
            Begin
             pix.att := (Attr And 7)+((Attr And 56) Shl 1);
            End;

           If (c<>#$20) And (c<>#$7F) And (c<>Char(Complement)) Then
            Begin
             If Attr And Graphik=0 Then pix.Car := MatGP0+(Byte(c)-32)
             Else pix.Car := MatGP1+(Byte(c)-32);

             pix.Att := pix.Att Or (128+8);
            End
           Else pix.Car := Byte(c);
          End
         Else pix.att := CDRCS;
        End
       Else pix.att := CDRCS;
      End;

     If VideoEGA And ((Attr And (Graphik+DRCS))=Graphik) And
        (Cfg.VAttr And VATTR_GRAPH<>0) Then
      Begin
       If Attr And Disjoint<>0 Then
        Begin
         If c<Char(32+64) Then
          pix.Car := MatG1D+((Byte(c)-32) And 63)
         Else pix.Car := MatG1D+((Byte(c)-64) And 63);
        End
       Else
        Begin
         If c>=#$40 Then
          Begin
           pix.Car := MatG1+(((Byte(c)-32) And 31) Xor 31);
           pix.att := (pix.att And Not(112+7)) Or
                      (((pix.att And 112) Shr 4)+
                       ((pix.att And 7) Shl 4));
          End
         Else pix.Car := MatG1+((Byte(c)-32) And 31);
        End;

       pix.Att := pix.Att Or 128;
      End;
   end;

 If VideoEga And Reverse Then
  Begin
   f := (pix.att And 112) Shr 4;
   t := (pix.att And 7);
   (*
   If f=t Then
    Begin
     If f<7 Then Inc(f)
     Else Dec(t);
    End;
   *)
   f := f xor 7;
   t := t xor 7;
   pix.att := (pix.att And Not(112+7)) Or t Or (f Shl 4);
   (*
   pix.att := (pix.att And Not(112+7)) Or f Or (t Shl 4);
   *)
  End;

 WrtDt(Byte(pix.car),20+x,y,pix.att);
End;


function Actif(colonne, ligne: byte) : boolean;
begin
  Actif := (colonne>=PXhaut) and (colonne<=PXbas) and
           (ligne>=PYhaut) and (ligne<=PYbas);
end;


Procedure _AffVdtChar( c : Char; x, y : Byte; Attr : Word );
Begin
 WrtVdtChar(c,x,y,Attr,FALSE);
End;

Procedure AffVdtChar( c : Char; x, y : Byte; Attr : Word );
Var pix : DtScr_Rec;
Begin
 if actif(x,y) then WrtVdtChar(c,x,y,Attr,FALSE)
 else
  If VideoEga Then WrtVdtChar(c,x,y,Attr,TRUE)
  Else
   Begin
    if c=#0 then
      begin
        pix.car := RIEN;
        pix.att := CRienOut;
      end
    else
      begin
        if (Attr and Graphik)=0 then pix.car := Byte(c)
        else pix.car := CarGraphik;
        pix.att := CToutOut;
      end;
    WrtDt(Byte(pix.car),20+x,y,pix.att);
   End;
End;


procedure AffDataShowCadre( x, y : byte);
{ considere comme active, toujours! }
Var a : Byte;
begin
 If VideoEga Then WrtVdtChar(cM^.Ram[y,x].Car,x,y,cM^.Ram[y,x].Att,TRUE)
 Else
  With cM^.Ram[y,x] Do
   if Car=#0 then WrtDt(RIEN,x+20,y,CCadreEvol)
   else
    Begin
     If Att And DRCS=0 Then a := CCadreEvol Else a := CCadreEvolDRCS;
     if (Att and Graphik)=0 then
      Begin
       WrtDt(Byte(Car),x+20,y,a);
      End
     else
      Begin
       WrtDt(CarGraphik,x+20,y,a);
      End;
    End;
end;


{ ***************** ATT CONTROL *************** }
function GivTxtAtt (ref : word; num_att : byte) : string;
begin
  if num_att<2 then GivTxtAtt := TxtCoul[ReadAtt(ref,num_att)]
  else
    if num_att=2 then GivTxtAtt := TxtTail[ReadAtt(ref,num_att)]
    else GivTxtAtt := TxtBin[ReadAtt(ref,num_att)];
end;

procedure AffAtt ( ref : word; num_att : byte);
begin
  WrtScr(TxtAtt[num_att],PanelX,PanelY+num_att,CMiNet);
  if AttActif[num_att] then
      WrtScr(GivTxtAtt(ref,num_att),PanelX+9,PanelY+num_att,CNet)
  else
      WrtScr('---------',PanelX+9,PanelY+num_att,CNet);
end;

{ ********************** GRAPHIK ********************* }

{ g = 0..63 }

Function  CalcGraphCode( g : Byte; DRCSActif : Boolean ) : Byte;
Begin
 g := (g And 63)+32;
 If ExtG1 And DRCSActif Then
  Begin
   If g=$5F Then g := $7F;
  End
 Else If (g>=$40) And (g<$5F) Then Inc(g,32);

 CalcGraphCode := g;
End;


procedure IncAtt( var ref : word; att : byte);
begin
  if ReadAtt(ref,att)>=bit_att[att].Long then WrtAtt(ref,att,0)
  else WrtAtt(ref,att,ReadAtt(ref,att)+1);
end;

procedure DecAtt( var ref : word; att : byte);
begin
  if ReadAtt(ref,att)=0 then WrtAtt(ref,att,bit_att[att].Long)
  else WrtAtt(ref,att,ReadAtt(ref,att)-1);
end;


end.
